
stages:
  - test
  - build
  - container-audit
  - deploy-docker
  - deploy-k8s

variables:
  DOCKER_USER: highsparrow4reel
  DOCKER_IMAGE: masaratapp-front
  AWS_REGION: eu-west-3
  EKS_CLUSTER_NAME: masaratapp


test:
 stage: test
 image: busybox
 script:
    - echo "testing..."
    - echo "done"

build:
  stage: build
  image: busybox
  script:
    - echo "Building..."
    # - npm run build

audit_image:
  stage: container-audit
  services:
    - docker:dind
  image:
    name: snyk/snyk:docker
    entrypoint: ['']

  before_script:
    - export DOCKER_HOST=tcp://docker:2375
    - snyk auth $SNYK_TOKEN
    - docker --host=tcp://docker:2375 build -t $DOCKER_USER/$DOCKER_IMAGE:latest .
  script:
    - echo "Auditing image"
    - snyk container test $DOCKER_USER/$DOCKER_IMAGE:latest --severity-threshold=medium --json > snyk.json
  artifacts:
    untracked: false
    paths:
      - snyk.json
    when: always


deploy to docker hub:
  stage: deploy-docker
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - export DOCKER_HOST=tcp://docker:2375
    - docker login --username $DOCKER_USER --password $DOCKER_PASS
  script:
    # - docker pull $DOCKER_USER/$DOCKER_IMAGE:latest || true # pull to utilize caching
    - docker build -t $DOCKER_USER/$DOCKER_IMAGE:$CI_PIPELINE_ID . 
    - docker tag $DOCKER_USER/$DOCKER_IMAGE:$CI_PIPELINE_ID $DOCKER_USER/$DOCKER_IMAGE:latest
    - docker push $DOCKER_USER/$DOCKER_IMAGE:$CI_PIPELINE_ID
    - docker push $DOCKER_USER/$DOCKER_IMAGE:latest


deploy to k8s:
  stage: deploy-k8s
  image: 
    name: alpine/k8s:1.25.14
    entrypoint: ['']
  script:
    - echo "Deploying to k8s"
    - aws eks --region $AWS_REGION update-kubeconfig --name $EKS_CLUSTER_NAME
    - kubectl config set-context --current
    - sed -i "s/ID_OF_LATEST_IMAGE_PIPE/$CI_PIPELINE_ID/g" k8s/deployment.yml
    - kubectl apply -f k8s/namespace.yml
    - kubectl apply -f k8s/deployment.yml
    - kubectl apply -f k8s/service.yml